package cn.ibizlab.humanresource.core.base.service;

import java.io.Serializable;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.util.Collection;
import java.math.BigInteger;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import com.alibaba.fastjson.JSONObject;
import org.springframework.cache.annotation.CacheEvict;

import cn.ibizlab.humanresource.core.base.domain.HROMHierarchy;
import cn.ibizlab.humanresource.core.base.filter.HROMHierarchySearchContext;


import com.baomidou.mybatisplus.extension.service.IService;

/**
 * 实体[HROMHierarchy] 服务对象接口
 */
public interface IHROMHierarchyService extends IService<HROMHierarchy>{

    boolean create(HROMHierarchy et) ;
    void createBatch(List<HROMHierarchy> list) ;
    boolean update(HROMHierarchy et) ;
    void updateBatch(List<HROMHierarchy> list) ;
    boolean remove(String key) ;
    void removeBatch(Collection<String> idList) ;
    HROMHierarchy get(String key) ;
    HROMHierarchy getDraft(HROMHierarchy et) ;
    boolean checkKey(HROMHierarchy et) ;
    boolean save(HROMHierarchy et) ;
    void saveBatch(List<HROMHierarchy> list) ;
    Page<HROMHierarchy> searchDefault(HROMHierarchySearchContext context) ;
    Page<HROMHierarchy> searchRootOrg(HROMHierarchySearchContext context) ;
    List<HROMHierarchy> selectByHromhierarchycatid(String omhierarchycatid) ;
    void removeByHromhierarchycatid(String omhierarchycatid) ;
    List<HROMHierarchy> selectByPomhierarchyid(String omhierarchyid) ;
    void removeByPomhierarchyid(String omhierarchyid) ;
    List<HROMHierarchy> selectByOrganizationid(String organizationid) ;
    void removeByOrganizationid(String organizationid) ;
    /**
     *自定义查询SQL
     * @param sql  select * from table where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return select * from table where id = '1'
     */
    List<JSONObject> select(String sql, Map param);
    /**
     *自定义SQL
     * @param sql  update table  set name ='test' where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return     update table  set name ='test' where id = '1'
     */
    boolean execute(String sql, Map param);

    List<HROMHierarchy> getHromhierarchyByIds(List<String> ids) ;
    List<HROMHierarchy> getHromhierarchyByEntities(List<HROMHierarchy> entities) ;
}


